package at.jku.students.set.tree;

import at.jku.ssw.graphviz.DotMaker;
import at.jku.ssw.queue.impl.LinkedListQueue;
import at.jku.ssw.set.BinaryTreeNode;
import at.jku.ssw.set.Set;

/**
 * A binary tree based set implementation of {@linkplain Comparable} objects.
 */
public class BinaryTreeSet extends Set {

	private BinaryTreeNode root;

	/**
	 * Adds the specified value to this set if it is not already present.
	 */
	@Override
	public void add(int value) {
		// TODO
	}

	/**
	 * Returns <code>true</code> if this set contains the specified object,
	 * otherwise <code>false</code>.
	 */
	@Override
	public boolean contains(int value) {
		// TODO
		return false;
	}

	/**
	 * Removes the specified value from this set if it is present.
	 *
	 * @return <code>true</code> if the set contained the specified value,
	 *         <code>false</code> otherwise.
	 */
	@Override
	public boolean remove(int value) {
		// TODO
		return false;
	}

	/**
	 * Returns the number of objects in this set.
	 */
	@Override
	public int size() {
		// TODO
		return -1;
	}

	/**
	 * Determines the maximal height of this tree. The maximal height of the
	 * tree is the maximal level of the leaf nodes.
	 * 
	 * @return the height of the tree.
	 */
	public int height() {
		// TODO
		return -1;
	}

	/**
	 * Determines the maximal width of this binary tree. The maximal width of
	 * the tree is the maximal number of nodes on one level of the tree.
	 * 
	 * @return the width of this tree.
	 */
	public int width() {
		// TODO
		return -1;
	}

	public String makeDot() {
		return DotMaker.makeDotForBinaryTree(root);
	}

	@Override
	public String toString() {
		return treeString();
	}

	/**
	 * Constructs a textual representation of the binary tree where each child
	 * node is represented in a {@link System#lineSeparator new line} prefixed
	 * with an indent character.
	 * 
	 * For example the following code
	 * 
	 * <code>
	 * <pre>
	 * 		BinaryTreeSet set=new BinaryTreeSet();
	 * 		set.add(2);
	 * 		set.add(3);
	 * 		set.add(1);
	 * 		System.out.println(set.treeString());
	 * </pre>
	 * </code>
	 * 
	 * should produce the output below:
	 * 
	 * <pre>
	 * => 2
	 *   => 1
	 *   => 3
	 * </pre>
	 * 
	 * <b>Hint:</b> use {@link System#lineSeparator()} to get the new line
	 * character.
	 * 
	 * @return
	 */
	public String treeString() {
		// TODO
		return null;
	}

	public BinaryTreeNode getRoot() {
		// TODO
		return null;
	}
}
